// www.elegoo.com
// 2018.10.24
/*
  LED1 should be lit, showing power. LED2 indicates sound input, and the sensitivity is adjusted by potentiometer.
  There is a tiny screw on the blue potentiometer block that you can use for adjustment. Turning that
  clockwise lowers the potentiometer value, while counter-clockwise raises the potentiometer value.
  Use the potentiometer to adjust the Sound Sensor sensitivity. Turn the potentiometer
  several rotations until you see the LED2 extinguish (or just faintly blink). This might be slightly greater than
  500, if you are also watching Serial Monitor (inital adjustment), or, Serial Plotter (the latter is prefererd for observation).
  Special thanks to user CRomer, for his input and hard work!
*/

int  sensorAnalogPin = A0;    // Select the Arduino input pin to accept the Sound Sensor's analog output 
int  sensorDigitalPin = 15;   // Select the Arduino input pin to accept the Sound Sensor's digital output
int  analogValue = 0;         // Define variable to store the analog value coming from the Sound Sensor
int  digitalValue;            // Define variable to store the digital value coming from the Sound Sensor
int  Ledon = 9;               // Define LED port; this is the LED built in to the Arduino (labled L)
int  Ledoff = 11;
#define BUZZER_PIN 13

#include <LiquidCrystal.h>
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);                            

void setup()
{
  Serial.begin(9600);               // The IDE settings for Serial Monitor/Plotter (preferred) must match this speed
  pinMode(sensorDigitalPin,INPUT);  // Define pin 7 as an input port, to accept digital input
  pinMode(sensorAnalogPin,INPUT);
  pinMode(Ledon,OUTPUT);            // Define LED13 as an output port, to indicate digital trigger reached
  pinMode(Ledoff,OUTPUT); 

}

void loop(){
  analogValue = analogRead(sensorAnalogPin); // Read the value of the analog interface A0 assigned to digitalValue 
  digitalValue=digitalRead(sensorDigitalPin); // Read the value of the digital interface 7 assigned to digitalValue 

  Serial.print("Analog val.: ");   
  Serial.print(analogValue); // Send the analog value to the serial transmit interface
  Serial.print("   Digital val.: ");   
  Serial.println(digitalValue); 

  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
  lcd.print("An:");
  lcd.setCursor(4, 0);
  lcd.print(analogValue);
  lcd.setCursor(10, 0);
  lcd.print("Dg:");
  lcd.setCursor(14, 0);  
  lcd.print(digitalValue);
  
  if(digitalValue==HIGH)      // When the Sound Sensor sends signla, via voltage present, light LED13 (L)
  {
    digitalWrite(Ledon,HIGH);
    digitalWrite(Ledoff,LOW);
    tone(BUZZER_PIN, millis()%1000+200); 
  lcd.setCursor(0, 1);
  lcd.print("RILEVATA PRESENZA"); 
//  lcd.print("RILEVATA FIAMMA! ");    //usare questa dicitura se si usa il sensore KY026, flame contro
//  lcd.print("RILEVATO SUONO!  ");    //usare questa dicitura se si usa i sensori KY037/8,big/small sound;
//  lcd.print("CAMPO MAGNETICO! ");    //usare questa dicitura se si usa il sensore KY024/5, linear hall/magnetic field control
//  lcd.print("CONTATTO MET.!   ");    //usare questa dicitura se si usa il sensore KY036, metal touch control  
  }
  else
  {
    digitalWrite(Ledon,LOW);
    digitalWrite(Ledoff,HIGH);
    noTone(BUZZER_PIN);
  lcd.setCursor(0, 1);
  lcd.print("Nessuna presenza  ");
//  lcd.print("Nessuna fiamma!   ");     //usare questa dicitura se si usa il sensore KY026, flame contro
//  lcd.print("Nessun suono!     ");     //usare questa dicitura se si usa i sensori KY037/8,big/small sound
//  lcd.print("No campi magn.!   ");     //usare questa dicitura se si usa il sensore KY024/5, linear hall/magnetic field control
//  lcd.print("Nessun contatto!  ");     //usare questa dicitura se si usa il sensore KY036, metal touch control  
  }
  delay(300);                  // Slight pause so that we don't overwhelm the serial interface
}
